;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;  328p
;  16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m328Pdef.inc"		;  ATMega328p


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;   / 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;



;******************************************************************************
; 
;******************************************************************************


 .dseg     ;  


;******************************************************************************
; 
;******************************************************************************


; .EQU	Constanta_1= 0x0001 		; 1 ( 16  )


;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  
				

; .org OC1Aaddr				; = 0x0016 Timer/Counter1 Compare Match A 
; rjmp OCR1A_COMP


.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        



;   "B"

	ldi Temp,0b00000010		;   "b" (0-, 1-)
	out DDRB,Temp			; 0000000 - "" 
					 
		
			

	ldi Temp,0b00000000		;  _0   "b" (   )  .
	out PortB,Temp			; 


;   "D"

	ldi Temp,0b01000000		;   "D" (0-, 1-)
	out DDRD,Temp			; 0000000 - "" 
					 
		
			

	ldi Temp,0b00000000		;  _0   "D" (   )   .
	out PortD,Temp			; 



				
;******************************************************************************
;   
;******************************************************************************


; _0 (  1024 )
; 8 
;    ( 3 : ,     )



					

	ldi Temp,(1<<COM0A1)|(0<<COM0A0)|(1<<WGM01)|(1<<WGM00)
	out TCCR0A, Temp	
				
					;    //   ,   
					; 
					; 


					; COM0A1  /   OC1A // 
					; COM0A0  /   OC1A // 
					; COM0B1  /   OC1B // 
					; COM0B0  /   OC1B //  
					; WGM01=1 /  *
					; WGM00=1 /  *





	ldi Temp,(0<<WGM02)|(1<<cs02)|(1<<cs00)	
	out TCCR0B, Temp					


					;   = CK 1:1024 
					;   !!!


					; WGM02=0 /  * 
					; CS02=1  /  
					; CS01=0  /   
					; CS00=0  /   = CK 1:1024 (16/1024=15625) 1   = 0,000064 



					; 16000000:1024=15625 
					; 1:15625=0,000064 
					; 0,000064*256=0,016384 
					; 0,000064*1=0,000064 



	ldi Temp, 0x1E			;   0  255
	out OCR0A, Temp			;  30











;******************************************************************************

; _1 (  1/64 )
; 16 
;        (  1  7  )





	LDI Temp, 0x0C						;    
	sts OCR1AH, Temp					;  0,05 ,  3125  ( 0x0C35 )
	LDI Temp, 0x35						;  0,10 ,  6250  ( 0x186A ) 					
	sts OCR1AL,Temp  					;






	ldi Temp, (1<<COM1A1)|(0<<COM1A0)|(1<<wgm11)|(0<<wgm10)	;      ( fast pwm - top = icr )
	sts TCCR1A, Temp					; 

								; COM1A1 /   OC1A
								; COM1A0 /   OC1A 
								; COM1B1 /   OC1B 
								; COM1B0 /   OC1B
								; 
								; 
								; WGM11=1 /  
								; WGM10=0 /  


	ldi Temp, (1<<WGM13)|(1<<WGM12)|(1<<cs12)|(0<<cs10)	;  
	sts TCCR1B, Temp					;     = CK 1:256
								;   !!!

								; ICNC1=0 / 
								; ICES1=0 / 
								; WGM13=1 /  
								; WGM12=1 /  
								; CS12=0
								; CS11=1 /   = CK 1:256 (16/256=62500) 1   = 0,000016 
								; CS10=0 





	LDI Temp, 0x22						;    8750  (   ~7 )
	sts ICR1H, Temp						;      
	LDI Temp, 0x2E						; 1:7=~0,14 ( 0,14:0,000016=8750)
	sts ICR1L, Temp						;



 


;	ldi Temp, (1<<OCIE1A)					;    
;	sts TIMSK1, Temp





	ldi Temp, 0						;   
	sts TCNT1H, Temp
	sts TCNT1L, Temp






;******************************************************************************
;   (     )
;******************************************************************************



;******************************************************************************
;  
;******************************************************************************			

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;******************************************************************************
;   
;******************************************************************************

	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************

main_cicle:


	LDI R16, 55			;   ''
	RCALL LCD_CHAR	

	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 49			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 52			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		
																				
	LDI R16, 53			;   ''
	RCALL LCD_CHAR
		

	LDI R16, 78			;   '.'
	RCALL LCD_CHAR						
			






main_cicle_1:

	rjmp main_cicle_1





;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	
